(*
 *                                                                                             .
 * Module name: Dialog_Utilities.pas; Module type: Delphi unit; Language: Delphi 5             .
 *                                                                                             .
 * Author: Marcus F. Nefzger AKA MNe (web:<http://www.nefzger.at/>; mailto:<MNe@nefzger.at>)   .
 * File created: Mon., 20.01.2003; Last modified: Thu., 26.06.2003                             .
 *                                                                                             .
 * Bug report: Report all bugs, wishes, suggestions etc. to <BugReport@nefzger.at>.            .
 *                                                                                             .
 *  Purpose:                                                                                   .
 * ----------                                                                                  .
 *                                                                                             .
 *)
unit
   Dialog_Utilities;

// ----------                                                                                  .
   interface
// ----------                                                                                  .

uses
   Windows,
   Forms,
   Dialogs;

function MessageDlgPosEx (const Sender: TForm;
                          const Msg: String;
                          const DlgType: TMsgDlgType;
                          const Buttons: TMsgDlgButtons;
                          const HelpCtx: Longint;
                          const XYOfs: TPoint): TModalResult;

function ShowFormModalAt (const Sender: TForm;
                          const ModalForm: TForm;
                          const XYOfs: TPoint): TModalResult;

// ---------------                                                                             .
   implementation
// ---------------                                                                             .

uses
   Misc_Utilities;

// -----------------------------------------------------------------------------               .
function MessageDlgPosEx (const Sender: TForm;
                          const Msg: String;
                          const DlgType: TMsgDlgType;
                          const Buttons: TMsgDlgButtons;
                          const HelpCtx: Longint;
                          const XYOfs: TPoint): TModalResult;
var
   r: TRect2;
begin
   if ((Sender <> NIL) and (Sender.Visible)) then begin
      r := guiRect2(Sender.Left,Sender.Top,0,0);
      with guiCenterFormOnForm(@r,NIL,guiPoint2(XYOfs.X,XYOfs.Y)) do
         Result := MessageDlgPos(Msg,DlgType,Buttons,HelpCtx,Left,Top);
   end else
      Result := MessageDlg(Msg,DlgType,Buttons,HelpCtx);
end;

// -----------------------------------------------------------------------------               .
function ShowFormModalAt (const Sender: TForm;
                          const ModalForm: TForm;
                          const XYOfs: TPoint): TModalResult;
var
   r, r2: TRect2;
begin
   if ((Sender <> NIL) and (Sender.Visible)) then begin
      r := guiRect2(Sender.Left,Sender.Top,Sender.Width,Sender.Height);
      r2 := guiRect2(0,0,ModalForm.Width,ModalForm.Height);
      with guiCenterFormOnForm(@r,@r2,guiPoint2(XYOfs.X,XYOfs.Y)) do begin
         ModalForm.Left := Left;
         ModalForm.Top := Top;
      end;
   end else begin
      r := guiRect2(0,0,ModalForm.Width,ModalForm.Height);
      with guiCenterFormOnScreen(@r,guiPoint2(0,0)) do begin
         ModalForm.Left := Left;
         ModalForm.Top := Top;
      end;
   end;
   Result := ModalForm.ShowModal();
end;

   // keine Initialisierung.                                                                   .
end.

