@rem Zuletzt gendert: 07:53 22.10.2005

@echo off

rem ------------------------------------------------------------------------------------------ .
rem                                                                                            .
rem  Abhngigkeiten:                                                                           .
rem -----------------                                                                          .
rem  .) Eine Version von Delphi 5 (oder gleichwertig) mu korrekt installiert sein; dies       .
rem     impliziert vor allem, da der Delphi-Kompiler (dcc32.exe) und der Resource-Komp-       .
rem     iler (brcc32) ber den Pfad erreichbar sind.                                           .
rem  .) Die Kommandozeilenversion von (Win-) ZIP, die mit langen Dateinamen umgehen kann;      .
rem     (Win-) ZIP wir in "%ProgramFiles%\winzip\" erwartet.                                   .
rem                                                                                            .
rem ------------------------------------------------------------------------------------------ .

set BRCC32_PATH=D:\Programme\Delphi5\Bin\
set DCC32_PATH=D:\Programme\Delphi5\Bin\
set WZZIP_PATH=C:\Programme\WinZip\

echo.

if exist nf.cfg del nf.cfg
if exist nf.dof del nf.dof
if exist nfGUI.cfg del nfGUI.cfg
if exist nfGUI.dof del nfGUI.dof

rem // ** ------------------------------------------------------------------------------------ .
rem // **                                                                                      .
rem // ** Resource(n) vorbereiten                                                              .
rem // **                                                                                      .
rem // ** ------------------------------------------------------------------------------------ .

rem *** ..\toolhelp\mk_datetime > nf.datetime
echo ~~
echo ~~ ..\toolhelp\VerGen.exe -File .\nf.verinfo.rc -IncBuildAndExit
echo ~~ "%BRCC32_PATH%brcc32" nf.verinfo.rc -fonf.verinfo.res
echo ~~
if exist ..\toolhelp\VerGen.exe ..\toolhelp\VerGen.exe -File .\nf.verinfo.rc -IncBuildAndExit
"%BRCC32_PATH%brcc32" nf.verinfo.rc -fonf.verinfo.res

rem *** ..\toolhelp\mk_datetime > nfGUI.datetime
echo ~~
echo ~~ ..\toolhelp\VerGen.exe -File .\nfGUI.verinfo.rc -IncBuildAndExit
echo ~~ "%BRCC32_PATH%brcc32" nfGUI.verinfo.rc -fonfGUI.verinfo.res
echo ~~
if exist ..\toolhelp\VerGen.exe ..\toolhelp\VerGen.exe -File .\nfGUI.verinfo.rc -IncBuildAndExit
"%BRCC32_PATH%brcc32" nfGUI.verinfo.rc -fonfGUI.verinfo.res

if exist all.motd.joke.* (
   ren all.motd.inc all.motd.backup.inc
   ren all.motd.joke.inc all.motd.inc
   echo.
   echo !!
   echo !! Original-motd gesichert, Joke-motd vorbereitet.
   echo !!
)

echo.

rem ------------------------------------------------------------------------------------------ .
rem                                                                                            .
rem   Bei der Komandozeilenversion dcc32.exe gibt es (zumindest in der Kombination Delphi 5,   .
rem Update Pack #1 -- Microsoft Windows 2000, v5.00.2195) folgendes _seltsames_ Verhalten:     .
rem   Wie zu erkennen ist, kompiliert der nachfolgede Batch ein und das selbe Projekt 2x       .
rem hintereinander; lediglich die Flags/ Defines sind unterschiedlich (1x Debug- und 1x        .
rem Final-Build). So weit, so gut, allerdings mit folgendem Drawback:                          .
rem   Wird der Skript so gestartet, da beide Projekte in der selben Minute kompiliert         .
rem werden, funktioniert das nicht: es wird lediglich das *.dpr neu bersetzt, und die         .
rem Units bleiben vom ersten Kompilerlauf 'ber' -- und das, obwohl der Schalter '-B'          .
rem (= Build all Units) angegeben ist!!!                                                       .
rem   Wenn allerdings der erste Build in Minute X, und der zweite Build in Minute X+1 (oder    .
rem spter) durchgefhrt wird, dann klappt es wie erwartet und der Schalter '-B' macht, was    .
rem er tun sollte.                                                                             .
rem                                                                                            .
rem Ich gebe es zu: ich habe mir nicht die Mhe gemacht, herauszufinden, woran es liegt ...    .
rem                                                                                            .
rem Work-Around: alle zugeh. *.dcu's vor dem Kompilerlauf lschen ...                          .
rem                                                                                            .
rem ------------------------------------------------------------------------------------------ .

rem // ** ------------------------------------------------------------------------------------ .
rem // **                                                                                      .
rem // ** Debug-Version erstellen                                                              .
rem // **                                                                                      .
rem // ** ------------------------------------------------------------------------------------ .

if exist *.dcu del *.dcu
if exist "%TEMP%\*.dcu" del "%TEMP%\*.dcu"

rem *** -V .. Debug-Info in EXE > optional angeben
set DEBUG_Switches=-B -CC -GD -H -W -N"%TEMP%"
rem *** getestet und fr gut befunden: :-)
set DEBUG_ConDefs=-$A+ -$B- -$C+ -$D+ -$L+ -$Y+ -$H+ -$I+ -$J- -$O- -$Q+ -$R+ -$T- -$U+ -$W+ -$X+ -$Z4
echo ~~
echo ~~ "%DCC32_PATH%dcc32" %DEBUG_Switches% %DEBUG_ConDefs% nf.dpr
echo ~~ "%DCC32_PATH%dcc32" %DEBUG_Switches% %DEBUG_ConDefs% nfGUI.dpr
echo ~~
"%DCC32_PATH%dcc32" %DEBUG_Switches% %DEBUG_ConDefs% nf.dpr
if exist nf.debug.exe del nf.debug.exe
if exist nf.exe ren nf.exe nf.debug.exe
if exist nf.debug.map del nf.debug.map
if exist nf.map ren nf.map nf.debug.map
"%DCC32_PATH%dcc32" %DEBUG_Switches% %DEBUG_ConDefs% nfGUI.dpr
if exist nfGUI.debug.exe del nfGUI.debug.exe
if exist nfGUI.exe ren nfGUI.exe nfGUI.debug.exe
if exist nfGUI.debug.map del nfGUI.debug.map
if exist nfGUI.map ren nfGUI.map nfGUI.debug.map
set DEBUG_ConDefs=
set DEBUG_Switches=

echo.

rem // ** ------------------------------------------------------------------------------------ .
rem // **                                                                                      .
rem // ** Final-Version erstellen                                                              .
rem // **                                                                                      .
rem // ** ------------------------------------------------------------------------------------ .

if exist *.dcu del *.dcu
if exist "%TEMP%\*.dcu" del "%TEMP%\*.dcu"

rem *** getestet und fr gut befunden: :-)
set FINAL_Switches=-B -CC -GD -H -W -N"%TEMP%"
rem *** C .. Assertions     > optional C+
rem *** U .. FDIV Woraround > optional U-
set FINAL_ConDefs=-$A+ -$B- -$C- -$D- -$L- -$Y- -$H+ -$I- -$J- -$O+ -$Q- -$R- -$T- -$U+ -$W- -$X+ -$Z4
echo ~~
echo ~~ "%DCC32_PATH%dcc32" %FINAL_Switches% %FINAL_ConDefs% nf.dpr
echo ~~ "%DCC32_PATH%dcc32" %FINAL_Switches% %FINAL_ConDefs% nfGUI.dpr
echo ~~
"%DCC32_PATH%dcc32" %FINAL_Switches% %FINAL_ConDefs% nf.dpr
"%DCC32_PATH%dcc32" %FINAL_Switches% %FINAL_ConDefs% nfGUI.dpr
set FINAL_ConDefs=
set FINAL_Switches=

rem // ** ------------------------------------------------------------------------------------ .
rem // **                                                                                      .
rem // ** GGf. Resource(n) zurcksetzen                                                        .
rem // **                                                                                      .
rem // ** ------------------------------------------------------------------------------------ .

if exist all.motd.backup.* (
   ren all.motd.inc all.motd.joke.inc
   ren all.motd.backup.inc all.motd.inc
   echo.
   echo !!
   echo !! Original-motd wieder hergestellt.
   echo !!
)

echo.

rem // ** ------------------------------------------------------------------------------------ .
rem // **                                                                                      .
rem // ** ZIP-Archive erzeugen                                                                 .
rem // **                                                                                      .
rem // ** ------------------------------------------------------------------------------------ .

rem // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! .
cd ..
rem // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! .

set readme_file=nf.README.txt

echo.> %readme_file%
echo --------------->> %readme_file%
echo  :: PURPOSE ::>> %readme_file%
echo --------------->> %readme_file%
echo.>> %readme_file%
echo 'nf' is:>> %readme_file%
echo   A program to calculate *really* large faculties and>> %readme_file%
echo   is a tool for the console (= command prompt).>> %readme_file%
echo.>> %readme_file%
echo 'nfGUI' is:>> %readme_file%
echo   For those lusers who can't stand a console utility>> %readme_file%
echo   (so 'nfGUI' is a GUI wrapper for 'nf', as the name>> %readme_file%
echo    of the program hints :-).>> %readme_file%
echo.>> %readme_file%
echo Note: 'nfGUI' may not be part of the current package.>> %readme_file%
echo Note 2: The source code may not be part of the current package.>> %readme_file%
echo.>> %readme_file%
echo ----------------->> %readme_file%
echo  :: COPYRIGHT ::>> %readme_file%
echo ----------------->> %readme_file%
echo.>> %readme_file%
echo 'nf' and 'nfGUI' are:>> %readme_file%
echo   Copyright (c) 2002, 2005 ~SoffyT (MissyQueen@nefzger.at)>> %readme_file%
echo   Copyright (c) 2002, 2005 Marcus F. Nefzger (Marcus@nefzger.at)>> %readme_file%
echo.>> %readme_file%
echo --------------------->> %readme_file%
echo  :: THE AUTHOR(s) ::>> %readme_file%
echo --------------------->> %readme_file%
echo.>> %readme_file%
echo You can reach '~SoffyT' via:>> %readme_file%
echo   web: http://www.nefzger.at/~SoffyT/>> %readme_file%
echo   mailto: MissyQueen@nefzger.at>> %readme_file%
echo.>> %readme_file%
echo You can reach 'Marcus F. Nefzger' via:>> %readme_file%
echo   web: http://www.nefzger.at/>> %readme_file%
echo   mailto: Marcus@nefzger.at>> %readme_file%
echo.>> %readme_file%
echo Pls. direct all wishes, suggestions, bug reports etc. to:>> %readme_file%
echo   mailto:BugReport@nefzger.at>> %readme_file%
echo.>> %readme_file%
echo The original home of 'nf' and 'nfGUI' is located at:>> %readme_file%
echo   web: http://www.nefzger.at/~SoffyT/ --hosted by>> %readme_file%
echo   web: http://www.nefzger.at/>> %readme_file%
echo.>> %readme_file%
echo --------------------------------------->> %readme_file%
echo  :: DISCLAIMER, USAGE, DISTRIBUTION ::>> %readme_file%
echo --------------------------------------->> %readme_file%
echo.>> %readme_file%
echo THIS PACKAGE (MAY CONTAIN EXECUTABLE[s] and/or SOURCE FILE[s]>> %readme_file%
echo and/or DATA FILE[s] ..) IS DISTRIBUTED IN THE HOPE THAT IT IS>> %readme_file%
echo USEFUL, BUT WITHOUT WARRENTY OF ANY KIND, INCLUDING MERCHANT->> %readme_file%
echo ABILITY OF FITNESS FOR A PARTICULAR -- OR EVEN ANY -- PURPOSE.>> %readme_file%
echo SEE THE GNU-GPL FOR FULL DETAILS.>> %readme_file%
echo.>> %readme_file%
echo THIS PACKAGE IS DISTRIBUTED UNDER THE THERMS OF THE GNU-GPL>> %readme_file%
echo (GNU GENERAL PUBLIC LICENSE), SEE:>> %readme_file%
echo.>> %readme_file%
echo   http://www.gnu.org/licenses/gpl.html (format: html) --or-->> %readme_file%
echo   http://www.gnu.org/licenses/gpl.txt (format: plain text)>> %readme_file%
echo.>> %readme_file%
echo FOR FULL DETAILS.>> %readme_file%
echo.>> %readme_file%
echo                                                        The author,>> %readme_file%
echo                                  2005/10, Vienna, Austria, EUrope.>> %readme_file%

set Archive_Name=nf_ExeOnly.zip
if exist wzzip_filelist.temp del wzzip_filelist.temp
if exist %Archive_Name% del %Archive_Name%
echo %readme_file% > wzzip_filelist.temp
echo projects\nf.exe >> wzzip_filelist.temp
"%WZZIP_PATH%wzzip" -a -ex -P %Archive_Name% @wzzip_filelist.temp
if exist projects\%Archive_Name% del projects\%Archive_Name%
move %Archive_Name% projects\

set Archive_Name=nfGUI_ExeOnly.zip
if exist wzzip_filelist.temp del wzzip_filelist.temp
if exist %Archive_Name% del %Archive_Name%
echo %readme_file% > wzzip_filelist.temp
echo projects\nf.exe >> wzzip_filelist.temp
echo projects\nfGUI.exe >> wzzip_filelist.temp
"%WZZIP_PATH%wzzip" -a -ex -P %Archive_Name% @wzzip_filelist.temp
if exist projects\%Archive_Name% del projects\%Archive_Name%
move %Archive_Name% projects\

set Archive_Name=nf_ExeAndSource.zip
if exist wzzip_filelist.temp del wzzip_filelist.temp
if exist %Archive_Name% del %Archive_Name%
echo %readme_file% > wzzip_filelist.temp
echo includes\Globals.inc >> wzzip_filelist.temp
echo includes\MissingInFPC.pas >> wzzip_filelist.temp
echo core_utilities\CmdLine_Utilities.pas >> wzzip_filelist.temp
echo core_utilities\Dialog_Utilities.pas >> wzzip_filelist.temp
echo core_utilities\Misc_Utilities.pas >> wzzip_filelist.temp
echo bogus_classes\Fakultaet.pas >> wzzip_filelist.temp
echo projects\nf.exe >> wzzip_filelist.temp
echo projects\nf.dpr >> wzzip_filelist.temp
echo projects\nf.ico >> wzzip_filelist.temp
echo projects\nf.verinfo.rc >> wzzip_filelist.temp
echo projects\nf.verinfo.res >> wzzip_filelist.temp
echo projects\nf.verinfo.or >> wzzip_filelist.temp
echo projects\all.motd.inc >> wzzip_filelist.temp
echo projects\all.fatalerror.inc >> wzzip_filelist.temp
echo projects\~make_nf.bat >> wzzip_filelist.temp
"%WZZIP_PATH%wzzip" -a -ex -P %Archive_Name% @wzzip_filelist.temp
if exist projects\%Archive_Name% del projects\%Archive_Name%
move %Archive_Name% projects\

set Archive_Name=nfGUI_ExeAndSource.zip
if exist wzzip_filelist.temp del wzzip_filelist.temp
if exist %Archive_Name% del %Archive_Name%
echo %readme_file% > wzzip_filelist.temp
echo includes\Globals.inc >> wzzip_filelist.temp
echo includes\MissingInFPC.pas >> wzzip_filelist.temp
echo core_utilities\CmdLine_Utilities.pas >> wzzip_filelist.temp
echo core_utilities\Dialog_Utilities.pas >> wzzip_filelist.temp
echo core_utilities\Misc_Utilities.pas >> wzzip_filelist.temp
echo bogus_classes\Fakultaet.pas >> wzzip_filelist.temp
echo projects\nf.exe >> wzzip_filelist.temp
echo projects\nf.dpr >> wzzip_filelist.temp
echo projects\nf.ico >> wzzip_filelist.temp
echo projects\nf.verinfo.rc >> wzzip_filelist.temp
echo projects\nf.verinfo.res >> wzzip_filelist.temp
echo projects\nf.verinfo.or >> wzzip_filelist.temp
echo projects\nfGUI.exe >> wzzip_filelist.temp
echo projects\nfGUI.dpr >> wzzip_filelist.temp
echo projects\nfGUI.res >> wzzip_filelist.temp
echo projects\nfGUI.verinfo.rc >> wzzip_filelist.temp
echo projects\nfGUI.verinfo.res >> wzzip_filelist.temp
echo projects\nfGUI_u.pas >> wzzip_filelist.temp
echo projects\nfGUI_u.dfm >> wzzip_filelist.temp
echo projects\nfGUI_u_Frame.pas >> wzzip_filelist.temp
echo projects\nfGUI_u_Frame.dfm >> wzzip_filelist.temp
echo projects\all.motd.inc >> wzzip_filelist.temp
echo projects\all.fatalerror.inc >> wzzip_filelist.temp
echo projects\~make_nf.bat >> wzzip_filelist.temp
"%WZZIP_PATH%wzzip" -a -ex -P %Archive_Name% @wzzip_filelist.temp
if exist projects\%Archive_Name% del projects\%Archive_Name%
move %Archive_Name% projects\

set Archive_Name=
if exist wzzip_filelist.temp del wzzip_filelist.temp

if exist %readme_file% del %readme_file%
set readme_file=

rem // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! .
cd projects
rem // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! .

set WZZIP_PATH=
set DCC32_PATH=
set BRCC32_PATH=

rem // ** ------------------------------------------------------------------------------------ .
rem // **                                                                                      .
rem // ** Erzeugte Dateien auflisten                                                           .
rem // **                                                                                      .
rem // ** ------------------------------------------------------------------------------------ .

echo.
echo  Build-Skript ist beendet:
echo ---------------------------
echo.
dir nf.exe | find ".exe"
dir nf.map | find ".map"
dir nfGUI.exe | find ".exe"
dir nfGUI.map | find ".map"
echo.
dir nf_ExeOnly.zip | find ".zip"
dir nf_ExeAndSource.zip | find ".zip"
dir nfGUI_ExeOnly.zip | find ".zip"
dir nfGUI_ExeAndSource.zip | find ".zip"
echo.
dir nf.debug.exe | find ".exe"
dir nf.debug.map | find ".map"
dir nfGUI.debug.exe | find ".exe"
dir nfGUI.debug.map | find ".map"

rem // ** ------------------------------------------------------------------------------------ .

set TOUCH_FILE=%0.log
echo ------------->> %TOUCH_FILE%
date /t>> %TOUCH_FILE%
time /t>> %TOUCH_FILE%
set TOUCH_FILE=
